#!/usr/bin/env python
# this is <seifeio.py>
# ----------------------------------------------------------------------------
# 
# Copyright (c) 2023 by Thomas Forbriger (KIT, GPI, BFO) 
# 
# seife format I/O module
#
# Copyright 2023 by Thomas Forbriger
#
# ----
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
# ----
#
# REVISIONS and CHANGES 
#    24/02/2023   V1.0   Thomas Forbriger
#    05/03/2023   V1.1   fix reading parameter line
# 
# ============================================================================
#
"""
 This module supports file I/O in seife format.

 This seife format is defined by E. Wielandt for his time series analysis
 programs. A copy of the Fortran source code is available at
 http://www.software-for-seismometry.de

 The format description as copied from seife.doc
 -----------------------------------------------

 This format was defined prior to most other presently used data formats,
 and I am still adhering to it although it is now obsolete. The structure
 of the data files is as follows:

 - one header line, arbitrary (will be echoed but not evaluated) 
 - up to 48 comment or protocol lines marked with a  % character in the
   first column. Protocol lines are automatically generated by SEIFE
   unless seife.par contains the code 'ncl' (no comment lines).
 - one line containing the number of samples, the FORTRAN format in which
   they are listed, the sampling interval, and an optional time stamp as
   described below.
 - data in the specified format (here 5f10.3, that is, five entries like
   123456.789 per line).

 The entries in the last header line (which is the second line if there
 are no comments)  must be in the FORTRAN format (i10,a20,f10.x). It may
 contain a time stamp, in which case the format is (i10,a20,3f10.x). The
 time stamp consists of two numbers: minutes and seconds after midnight.
 No date can be encoded, except by expressing it in minutes. The whole
 line might read:         

 12000     (5f10.3)            0.01      617.      23.45

 The strings begin at positions 1, 11, 31, 41, 51. The time of the first
 sample is 10:17:23.45.

 The SEIFE format applies only to files read with the 'fil infile outfile'
 command line, and to the output files. Other ASCII data formats can be
 read with the asc, asl, bdf and mar commands; seife, gnuplot, and
 headerless single-column ASCII formats can be specified for the output.
 Miniseed files can be converted into ASL format with Quanterra's CIMARRON
 software, and then read with SEIFE. A converter from GSE to ASCII format
 named CODECO written by Urs Kradolfer is also available. I am offering a
 WINDOWS executable of this program.

 Specific format supported by this module
 ----------------------------------------

 Since we do not provide a full featured Fortran format parser, we limit
 the supported data format to an arbitrary sequence of floating point
 numbers separated by whitespace. This is any sequence, which can be read
 sequentially by numpy.loadtxt. If your data has no whitespace
 separating individual values (which is possible with fixed formats in
 Fortran), you should use the Fortran seife.f program itself to convert
 the data.

 The appropriate data format for output is

 50 format (6(g12.5,1x))

 This produces

 0.84147E+34  0.90930E+34  0.14112E+34 -0.75680E+34 -0.95892E+34 -0.27942E+34
 0.65699E+34  0.98936E+34  0.41212E+34 -0.54402E+34 -0.99999E+34 -0.53657E+34
 0.42017E+34  0.99061E+34  0.65029E+34 -0.28790E+34 -0.96140E+34 -0.75099E+34
 0.14988E+34  0.91295E+34
 
"""

# ======================================================================

from obspy.core.trace import Trace
from obspy.core.trace import Stats
from obspy.core.utcdatetime import UTCDateTime
from obspy.core.util.attribdict import AttribDict
import numpy as np
from io import StringIO

# ======================================================================

def read(filename, date="1970-01-01", 
         network="NSP", station="NSP", location="", channel="NSP",
         debug=False):
    """
    Read trace from seife file

    The date for the first sample as well as SEED codes are not stored in
    seife format and are not available from the input file.

    Parameters
    ----------
    filename : str
        name of file to read
    date : string
        date in format YYYY-MM-DD is needed, because the seife header
        does only specify time since midnight
    network : string
        SEED network code
    station : string
        SEED station code
    location : string
        SEED location code
    channel : string
        SEED channel code
    debug : bool
        produce debug output if True

    Return
    ------
    tr : obspy.Trace
    """
    if debug:
        print("DEBUG: open file %s" % filename)

    freeblock=list()
    nhlines=0
    with open(filename, 'r') as f:
        readheader=True
        while readheader:
            line=f.readline().rstrip()
            nhlines=nhlines+1
            if nhlines == 1:
                comment=line
            else:
                if line[0:1] == "%":
                    freeblock.append(line[1:])
                else:
                    parameterline=line
                    readheader=False

        # read time series samples as a whitespace separated list
        data=np.loadtxt(StringIO(" ".join(map(str.strip, f.readlines())))) 

    if debug:
        print("DEBUG: read %d header lines" % nhlines)
        print("DEBUG: comment line:")
        print("DEBUG: '%s'" % comment)
        print("DEBUG: free block:")
        for line in freeblock:
            print("DEBUG: %s" % line)
        print("DEBUG: parameterline:")
        print("DEBUG: '%s'" % parameterline)
        print("DEBUG:  1-10 '%s'" % parameterline[0:10])
        print("DEBUG: 11-20 '%s'" % parameterline[10:20])
        print("DEBUG: 21-40 '%s'" % parameterline[20:40])
        print("DEBUG: 41-50 '%s'" % parameterline[40:50])
        print("DEBUG: 51-60 '%s'" % parameterline[50:60])

    # extract header parameters
    stats=Stats()
    seife=AttribDict()
    seife["seifecomment"]=comment
    seife["seifeFREE"]=freeblock

    stats.network=network
    stats.station=station
    stats.location=location
    stats.channel=channel
    stats.npts=int(parameterline[0:10])
    seife["seifeformat"]=parameterline[10:30].strip()
    stats.delta=float(parameterline[30:40])
    stats.sampling_rate=1./stats.delta
    tmin=float(parameterline[40:50])
    tsec=float(parameterline[50:60])
    stats.starttime=UTCDateTime(date)+tsec+60*tmin

    stats.update(seife)

    # check consistency of number of samples
    if len(data) != stats.npts:
        print("ERROR when reading %s" % filename)
        print("ERROR: number of samples announced in header: %d" % nsamples)
        print("ERROR: number of samples provided: %d" % len(data))

    if debug:
        print("DEBUG: data (nsamples: %d):" % len(data))
        print(data)
        print("DEBUG: header")
        print(stats)

    # put everthing together
    stats.npts=len(data)
    trace=Trace(data, stats)

    if debug:
        print ("%35s: %s"       % ("name of data file", filename))
        print ("%35s: %s.%s.%s.%s" % ("network.station.location.channel",
                                   stats.network, stats.station,
                                   stats.location, stats.channel))
        print ("%35s: %s"       % ("time of first sample", stats.starttime))
        print ("%35s: %7.4f s"  % ("sampling interval", stats.delta))
        print ("%35s: %d"       % ("number of samples", stats.npts))
        print ("obspy header data:\n%s" % str(stats))

    # return obspy trace
    return trace

# ======================================================================

def write(filename, tr, debug=False):
    """
    Write trace to file in seife format

    Parameters
    ----------
    filename : str
        name of file to be written
    tr : obspy.Trace
        trace to be written to file
    debug : bool
        produce debug output if True
    """
    if debug:
        print("DEBUG: open file %s" % filename)
    with open(filename, 'w') as f:
        # write comment line
        f.write("obspy.Trace written by python function seifeio.write to %s\n" %
                filename)
        # write stats header as a free block
        f.write("% trace header (truncated at character 77):\n")
        for line in str(tr.stats).split(sep="\n"):
            llen=len(line)
            if llen > 77:
                llen=77
            f.write("%% %s\n" % line[0:llen])
        # write parameter line
        hours=tr.stats.starttime.hour
        minutes=tr.stats.starttime.minute
        seconds=tr.stats.starttime.second
        microseconds=tr.stats.starttime.microsecond
        f.write("{:<10d}{:<20s}{:<10f}{:<10f}{:<10f}\n".format(len(tr.data), 
                                  "(6(g12.5,1x))", tr.stats.delta, 
                                  hours*60+minutes,
                                  seconds+1.e-6*microseconds))
        # write time series samples 
        nval=0
        for v in tr.data:
            f.write("{:<+12.5E} ".format(v))
            nval=nval+1
            if nval > 5:
                f.write("\n")
                nval=0

# - END OF seifeio.py ----- 
